#include <stdlib.h>
#include "parlib.h"

#ifdef FORTRANUNDERSCORE
void p_bexchange_init_ ( ndims, stride, blklen, bdim, overlap, datatype, 
		comm, period, bexchange, ierr )
#elif defined(FORTRANDOUBLEUNDERSCORE)
void p_bexchange_init__ ( ndims, stride, blklen, bdim, overlap, datatype,
		comm, period, bexchange, ierr )
#else
void p_bexchange_init ( ndims, stride, blklen, bdim, overlap, datatype, 
		comm, period, bexchange, ierr )
#endif

   MPI_Fint *datatype, *ndims, *stride, *blklen, *bdim, *overlap, 
		*period, *ierr, *comm; 
	BExchange **bexchange;
{
   *bexchange = (BExchange *) malloc ( sizeof (BExchange) );
   *ierr = P_BExchange_init ( (int)*ndims, (int *)stride, (int *)blklen,
	(int)*bdim, (int *)overlap, MPI_Type_f2c(*datatype), 
	MPI_Comm_f2c(*comm), (int)*period, *bexchange );
}

#ifdef FORTRANUNDERSCORE
void p_bexchange_start_ ( a, bexchange, ierr )
#elif defined(FORTRANDOUBLEUNDERSCORE)
void p_bexchange_start__ ( a, bexchange, ierr )
#else
void p_bexchange_start ( a, bexchange, ierr )
#endif

   void *a;
   BExchange **bexchange;
	MPI_Fint *ierr;
{
   *ierr = P_BExchange_start ( a, *bexchange );
}

#ifdef FORTRANUNDERSCORE
void p_bexchange_end_ ( bexchange, ierr )
#elif defined(FORTRANDOUBLEUNDERSCORE)
void p_bexchange_end__ ( bexchange, ierr )
#else
void p_bexchange_end ( bexchange, ierr )
#endif

   BExchange **bexchange;
   MPI_Fint *ierr;
{
   *ierr = P_BExchange_end ( *bexchange );
}

#ifdef FORTRANUNDERSCORE
void p_bexchange_free_ ( bexchange, ierr )
#elif defined(FORTRANDOUBLEUNDERSCORE)
void p_bexchange_free__ ( bexchange, ierr )
#else
void p_bexchange_free ( bexchange, ierr )
#endif
   BExchange **bexchange;
   MPI_Fint *ierr;
{
   P_BExchange_free ( *bexchange );
   free ( *bexchange );
}

#ifdef FORTRANUNDERSCORE
void p_bexchange_ ( a, ndims, stride, blklen, bdim, overlap, datatype,
		comm, period, ierr )
#elif defined(FORTRANDOUBLEUNDERSCORE)
void p_bexchange__ ( a, ndims, stride, blklen, bdim, overlap, datatype, 
		comm, period, ierr )
#else
void p_bexchange ( a, ndims, stride, blklen, bdim, overlap, datatype,
		comm, period, ierr )
#endif
	void *a;
   int *ndims, *stride, *blklen, *bdim, *overlap, *period, *ierr;
   MPI_Datatype *datatype;
   MPI_Comm *comm;
{
   *ierr = P_BExchange ( a, (int)*ndims, (int *)stride, (int *)blklen, 
		(int)*bdim, (int *)overlap, MPI_Type_f2c(*datatype), 
		MPI_Comm_f2c(*comm), (int)*period );
}
